<?php
require(dirname(__FILE__) .'/../header.php');
require(INC .'/browser/config.php');
require(INC .'/browser/cls_browser.php');

$dir = $wa->get_cookie('browser_current_dir');
$browser = new browser(DIR .$CONFIG['bind']);
$browser->set_dir($dir);
$curpath = $browser->root . $browser->dir;

if(!file_exists($curpath)) $wa->setmsg('INFO_BROWSER_ACTION', $wa->lng('browser.access'));

$_act = $wa->v('_act', 'system_req');
switch($_act){
	case 'do_upload':
		check_action($_act, $wa->lng('browser.upload'));
		check_space();
		$up = new do_upload();
		$up->overwrite = true;
		$up->set_path($curpath);
		$up->set_limit($CONFIG['type'], $CONFIG['size']);
		$res = $up->upload('_file');
		$arr['key'] = $res ? 'INFO_DONE' : 'INFO_FAIL';
		$arr['msg'] = "\"{$wa->lng('browser.upload')}\"";
		if($res) $arr['code'] = 'div.style.display="none";window.location.reload();';
		break;

	case 'do_adddir':
		check_action($_act, $wa->lng('browser.adddir'));
		check_space();
		$file = $wa->v('_file', 'system_str');
		$res = mkdir($curpath .'/'. $file);
		$arr['key'] = $res ? 'INFO_DONE' : 'INFO_FAIL';
		$arr['msg'] = "\"{$wa->lng('browser.adddir')}:$file\"";
		if($res) $arr['code'] = 'div.style.display="none";parent.frames["left"].refresh_folder();';
		break;

	case 'do_access':
		check_action($_act, $wa->lng('browser.access'));
		$file = $wa->v('_file', 'system_req');
		echo file_get_contents($curpath .'/'. $file);
		break;

	case 'do_addfile':
		check_action($_act, $wa->lng('browser.addfile'));
		check_space();
		$file = $wa->v('_file', 'system_req');
		$content = $wa->v('content', 'system_req', false);
		$res = file_put_contents("$curpath/$file", $content);
		$arr['key'] = $res ? 'INFO_DONE' : 'INFO_FAIL';
		$arr['msg'] = "\"{$wa->lng('browser.addfile')}\"";
		if($res !== false) $arr['code'] = 'div.style.display="none";window.location.reload();';
		break;

	case 'do_editfile':
		check_action($_act, $wa->lng('browser.editfile'));
		$file = $wa->v('_file', 'system_req');
		$content = $wa->v('content', 'system_req', false);
		if(!$wa->v('nobak')){
			$bakpath = $browser->get_bak_path();
			if(!file_exists($bakpath)) make_dir($bakpath);
			copy($curpath .'/'. $file, $bakpath .'/'. $file);
		}
		$res = file_put_contents("$curpath/$file", $content);
		$arr['key'] = $res ? 'INFO_DONE' : 'INFO_FAIL';
		$arr['msg'] = "\"{$wa->lng('browser.editfile')}\"";
		if($res !== false) $arr['code'] = 'div.style.display="none";';
		break;

	case 'do_rename':
		check_action($_act, $wa->lng('browser.rename'));
		$old = $wa->v('_old', 'system_req');
		$new = $wa->v('_new', 'system_req');
		$res = rename($curpath .'/'. $old, $curpath .'/'. $new);
		$arr['key'] = $res ? 'INFO_DONE' : 'INFO_FAIL';
		$arr['msg'] = "\"{$wa->lng('browser.rename')}\"";
		if(!$res) $arr['code'] = 'window.location.reload();';
		break;

	case 'do_chmode':
		check_action($_act, $wa->lng('browser.chmode'));
		$file = $wa->v('_file');
		$mode = $wa->v('_new', 'system_int');
		$res = chmod($curpath .'/'. $file, octdec($mode));
		$arr['key'] = $res ? 'INFO_DONE' : 'INFO_FAIL';
		$arr['msg'] = "\"{$wa->lng('browser.chmode')}\"";
		if(!$res) $arr['code'] = 'window.location.reload();';
		break;

	case 'do_deldir':
		check_action($_act, $wa->lng('browser.deldir'));
		if($browser->dir != '') $res = clear_dir($curpath, true);
		$arr['key'] = $res ? 'INFO_DONE' : 'INFO_FAIL';
		$arr['msg'] = "\"{$wa->lng('browser.deldir')}\"";
		if($res) $arr['code'] = 'div.style.display="none";parent.frames["left"].remove_folder();';
		break;

	case 'do_delfile':
		check_action($_act, $wa->lng('browser.delfile'));
		$file = $wa->v('_file', 'system_req');
		$res = unlink($curpath .'/'. $file);
		$arr['key'] = $res ? 'INFO_DONE' : 'INFO_FAIL';
		$arr['msg'] = "\"{$wa->lng('browser.delfile')}\"";
		if($res) $arr['code'] = 'window.location.reload();';
		break;
}
$wa->putmsg($arr);

function check_action($act, $msg){
	$act = preg_replace("/^(do_)/i", "", $act);
	$permission = preg_replace("/\s+/", "", $GLOBALS['CONFIG']['perm']);
	if(!preg_match("/(^\*$|\b". $act ."\b)/i", $permission)){
		$GLOBALS['wa']->setmsg('INFO_BROWSER_ACTION', $msg);
	}
}

function check_space(){
	$quota = $GLOBALS['CONFIG']['quota'];
	$used = $GLOBALS['wa']->me['usedsize'];
	if($quota >= 0 && $used >= $quota){
		$GLOBALS['wa']->setmsg('INFO_SPACE_EXCEED', $quota);
	}
}
?>