<?php
/* web@all CMS, Copyright (C) webatall.org, Author:poetbi@gmail.com, License: http://webatall.org/license.php */
class browser{
	public $root;
	public $dir;

	public function __construct($root = DIR){
		$this->root = $root;
		if(substr($this->root, -1) == '/') $this->root = substr($this->root, 0, -1);
		return true;
	}

	public function set_dir($dir = '/'){
		$dir = preg_replace("/((\.+)\/|\\\\|\/)+/", "/", "/$dir");
		if(substr($dir, -1) == '/') $dir = substr($dir, 0, -1);
		$this->dir = $dir;
	}

	public function get_path(){
		$path = WEB($this->root . $this->dir .'/');
		return $path;
	}

	public function get_bak_path(){
		return preg_replace("/^(". preg_quote(DIR, '/') .")/", DIR .'/bak', $this->root . $this->dir, 1);
	}

	public function get_cur_mode(){
		$full_path = $this->root . $this->dir;
		$path_mode = substr(sprintf('%o', fileperms($full_path . $subfile)), -4);
		return $path_mode;
	}

	public function count_dir(){
	global $CONFIG;
		if($CONFIG['quota'] > 0){
			$dir = $this->root . $this->dir;
			$arr = count_dir($dir);
			$usedsize = $arr['size'] / 1024 / 1024;
			$mem = new mod_member();
			$mem->usedsize($usedsize);
		}
	}

	public function show_folders(){
		$full_path = $this->root . $this->dir .'/';
		$indent = '20px';
		if($handle = opendir($full_path)){
			while(false !== ($subdir = readdir($handle))){
			   if($subdir != "." && $subdir != ".." && is_dir($full_path . $subdir)){
				   $short_path = $this->dir .'/'. $subdir;
				   echo '<li style="padding-left:'. $indent .'"><a href="javascript://" onclick="click_folder(this, \''. $short_path .'\');"><img src="img/folder_close.gif"> '. $subdir .'</a><ul></ul></li>';
			   }
			}
			closedir($handle);
		}
	}

	public function show_files(){
	global $wa;
		$full_path = $this->root . $this->dir .'/';
		$web_path = $this->get_path();
		if($handle = opendir($full_path)){
			while(false !== ($subfile = readdir($handle))){
				if(is_file($full_path . $subfile)){
					$short_path = $this->dir .'/'. $subfile;
					$arr = explode('.', $subfile);
					$file_suffix = strtolower(end($arr));

					if(function_exists("finfo_file")){
						$finfo = finfo_open(FILEINFO_MIME_TYPE);
						$file_mime_type = finfo_file($finfo, $full_path . $subfile);
						finfo_close($finfo);
					}else{
						$file_mime_type = $this->file_type($file_suffix);
					}
					$arr = explode('/', $file_mime_type);
					$file_type = current($arr);

					$file_icon = $this->file_type_icon($file_suffix, $file_type);
					
					$file_mtime = $this->file_edit_time($full_path . $subfile, $wa->lng('browser.modified'));

					$file_size = $this->file_size($full_path . $subfile);
					
					$file_mode = substr(sprintf('%o', fileperms($full_path . $subfile)), -4);
					
					$file_name = urldecode($subfile);

					$edit_str = ($file_type == 'text' || $file_suffix == 'xml') ? '<a href="javascript:scroll(0,0);" onclick="_do(this, \'editfile\')" class="button_edit" title="'. $wa->lng('browser.button_edit') .'"></a>' : '';

					$preview_str = ($file_type == 'image') ? ' onMouseOver="preview(this, \''. WEB($full_path) . $subfile .'\')"' : '';

					$bgcolor = $i % 2 == 0 ? '' : '#F8F8F8';
					$str .= '<tr path="'. $web_path .'" file="'. $subfile .'" cfile="'. $file_name .'"  bgcolor="'. $bgcolor .'" onMouseOver="this.bgColor=\'#eeeeee\';" onMouseOut="this.bgColor=\''. $bgcolor .'\'">';
					$str .= '<td><img src="'. $file_icon .'"> &nbsp; <span onclick="_do(this, \'rename\')"'. $preview_str .' class="pen">'. $file_name .'</span></td>';
					$str .= '<td>'. $file_size .'</td>';
					$str .= '<td>'. $file_mtime .'</td>';
					$str .= '<td><span title="'. $wa->lng('browser.chmode') .'" onclick="_do(this, \'chmode\')" class="pen">'. $file_mode .'</span></td>';
					$str .= '<td align="center">'. $edit_str .'</td>';
					$str .= '<td align="center"><a href="javascript://" onclick="_do(this, \'delfile\')" class="button_del" title="'. $wa->lng('browser.delfile') .'"></a></td>';
					$str .= '</tr>';
					$i++;
			   }
			}
			closedir($handle);
		}

		echo '<table width="100%" border="0" cellpadding="3" cellspacing="1">'. $str .'</table>';
	}
	
	private function file_type_icon($file_suffix, $file_type){
		$img = "img/type_{$file_suffix}.gif";
		if(!file_exists($img)){
			$img = "img/file_{$file_type}.gif";
		}
		return $img;
	}

	private function file_type($file_suffix){
		$arr = array(
			'asp' => 'text/plain',
			'aspx' => 'text/plain',
			'bmp' => 'image/bmp',
			'c' => 'text/plain',
			'css' => 'text/css',
			'doc' => 'application/msword',
			'exe' => 'application/octet-stream',
			'flv' => 'video/x-flv',
			'gif' => 'image/gif',
			'gz' => 'application/x-gzip',
			'htm' => 'text/html',
			'html' => 'text/html',
			'ico' => 'image/x-icon',
			'ini' => 'text/plain',
			'jpg' => 'image/jpeg',
			'js' => 'text/plain',
			'mdb' => 'application/x-msaccess',
			'mp3' => 'audio/mpeg',
			'mpg' => 'video/mpeg',
			'pdf' => 'application/pdf',
			'php' => 'text/plain',
			'png' => 'image/png',
			'rar' => 'application/rar',
			'rtf' => 'application/rtf',
			'sh' => 'text/plain',
			'swf' => 'application/x-shockwave-flash',
			'txt' => 'text/plain',
			'xls' => 'application/vnd.ms-excel',
			'xml' => 'text/xml',
			'7z' => 'application/x-7z-compressed',
			'zip' => 'application/zip'
		);
		
		if(array_key_exists($file_suffix, $arr)){ return $arr[$file_suffix]; }else{ return 'unknown'; }
	}

	private function file_edit_time($file, $text){
		$edittime = filemtime($file);
		$time = time() - $edittime;
		$date = get_date($edittime);
		switch(true){
			case ($time < 86400) :
				$date = '<span style="color:red" title="'. str_replace('%s', '', $text) .'">'. $date .'</span>'; break;
			case ($time < 86400 * 3) :
				$date = '<span style="color:blue" title="'. str_replace('%s', 3, $text) .'">'. $date .'</span>'; break;
			case ($time < 86400 * 7) :
				$date = '<span style="color:green" title="'. str_replace('%s', 7, $text) .'">'. $date .'</span>'; break;
			case ($time < 86400 * 30) :
				$date = '<span style="color:#f60" title="'. str_replace('%s', 30, $text) .'">'. $date .'</span>'; break;
		}
		return $date;
	}

	private function file_size($file){
		$size = filesize($file);
		return '<span style="color:#999">'. get_size($size) .'</span>';
	}
}
?>