<?php
/* web@all CMS, Copyright (C) webatall.org, Author:poetbi@gmail.com, License: http://webatall.org/license.php */
class do_image{
	public $width = 200;
	public $height = 150;
	public $thumb_path;
	public $wm_type = 0;
	public $wm_text;
	public $wm_color = '#000000';
	public $wm_pos = 0;
	public $wm_logo;
	
	public function __construct(){
		$this->thumb_path = DIR .'/file/'. $GLOBALS['wa']->me['member_id'] .'/thumbs';
		$this->wm_text = preg_replace("/^www\./i", '', SYS_HOSTNAME);
		$this->wm_logo = DIR .'/img/logo.gif';
	}

	public function set($w, $h){
		$this->width = $w;
		$this->height = $h;
	}
	
	public function thumbs($src, $dst = ''){
		$info = getimagesize($src);
		if($info[2] < 1 || $info[2] > 3) return '';
		$src_width = $info[0];
		$src_height = $info[1];	
		$_create = $this->_create($info[2]);
		$im = $_create($src);
		if(!$im) return '';

		$scale = min($this->width/$src_width, $this->height/$src_height);
		if($scale >= 1) return WEB($src);

		$dst_width = floor($scale * $src_width);
		$dst_height = floor($scale * $src_height);
		$img = imagecreatetruecolor($dst_width, $dst_height);
		imagecopyresized($img,$im,0,0,0,0,$dst_width,$dst_height,$src_width,$src_height);

		if(!$dst) $dst = basename($src);
		if(!file_exists($this->thumb_path)) make_dir($this->thumb_path);
		$thumbs = $this->thumb_path .'/'. $dst;
		imagejpeg($img, $thumbs, 75);
		imagedestroy($img);
		imagedestroy($im);
		return WEB($thumbs);
	}
	
	public function watermark($src){
		if($this->wm_type == 0) return false;
		$src_info = getimagesize($src);
		if($src_info[2] < 1 || $src_info[2] > 3) return false;
		$src_width = $src_info[0];
		$src_height = $src_info[1];
		if($this->wm_type == 1){
			$logo_width = imagefontwidth(5) * strlen($this->wm_text);
			$logo_height = imagefontheight(5);
		}else{
			$logo_info = getimagesize($this->wm_logo);
			$logo_width = $logo_info[0];
			$logo_height = $logo_info[1];
		}
		if($logo_width > $src_width * 0.4 || $logo_height > $src_height * 0.4) return false;

		switch($this->wm_pos){
			case 1 : $x = 3; $y = 3; break;
			case 2 : $x = ($src_width - $logo_width) / 2; $y = 3; break;
			case 3 : $x = $src_width - $logo_width - 3; $y = 3; break;
			case 4 : $x = 3; $y = ($src_height - $logo_height) / 2; break;
			case 5 : $x = ($src_width - $logo_width) / 2; $y = ($src_height - $logo_height) / 2; break;
			case 6 : $x = $src_width - $logo_width - 3; $y = ($src_height - $logo_height) / 2; break;
			case 7 : $x = 3; $y = $src_height - $logo_height - 3; break;
			case 8 : $x = ($src_width - $logo_width) / 2; $y = $src_height - $logo_height - 3; break;
			case 9 : $x = $src_width - $logo_width - 3; $y = $src_height - $logo_height - 3; break;
			default : $x = mt_rand(3, $src_width - $logo_width); $y = mt_rand(3, $src_height - $logo_height);
		}

		$_create = $this->_create($src_info[2]);
		$im = $_create($src);
		if($this->wm_type == 1){
			$arrcolor = $this->rgb2hex($this->wm_color);
			$intcolor = imagecolorallocate($im, $arrcolor[0], $arrcolor[1], $arrcolor[2]);
			imagestring($im, 5, $x, $y, $this->wm_text, $intcolor);
		}else{
			$_create = $this->_create($logo_info[2]);
			$logo_im = $_create($this->wm_logo);
			imagealphablending($im, true);
			imagecopymerge($im, $logo_im, $x, $y, 0, 0, $logo_width, $logo_height, 65);
			imagedestroy($logo_im);
		}
		$_write = $this->_write($src_info[2]);
		$_write($im, $src);
		imagedestroy($im);
	}

	private function _create($type){
		switch($type){
			case 1: $fun = 'imagecreatefromgif'; break;
			case 2: $fun = 'imagecreatefromjpeg'; break;
			case 3: $fun = 'imagecreatefrompng'; break;
		}
		return $fun;
	}

	private function _write($type){
		switch($type){
			case 1: $fun = 'imagegif'; break;
			case 2: $fun = 'imagejpeg'; break;
			case 3: $fun = 'imagepng'; break;
		}
		return $fun;
	}
	
	private function rgb2hex($rgb){
		$trans = array('A'=>'10', 'B'=>'11', 'C'=>'12', 'D'=>'13', 'E'=>'14', 'F'=>'15'); 
		$hex = array(); 
		$rgb = str_replace('#', '', strtoupper($rgb)); 
		for($x=0; $x<strlen($rgb); $x++){$hex[] = strtr($rgb[$x],$trans); }
		if(count($hex)==3){ 
			$hex[5] = $hex[2]; $hex[4] = $hex[2]; 
			$hex[3] = $hex[1]; $hex[2] = $hex[1]; 
			$hex[1] = $hex[0]; 
		} 
		$arr = array(($hex[0]*16+$hex[1]), ($hex[2]*16+$hex[3]), ($hex[4]*16+$hex[5])); 
		return $arr; 
	}
}
?>