<?php
/* web@all CMS, Copyright (C) webatall.org, Author:poetbi@gmail.com, License: http://webatall.org/license.php */
class do_sendmail{
	public $subject;
	public $body;
	public $priority = 3;
	public $charset = 'UTF-8';
	public $content_type = 'text/html';
	public $encoding = 'base64';

	public $smtp = array(
		'host' => '',
		'port' => 25,
		'user' => '',
		'pass' => '',
		'helo' => '',
		'timeout' => 10
	);
	
	private $sender = '';
	private $from = array();
	private $to = array();
	private $sock = null;
	private $mailer = 'mail';
	private $EOL = "\n";
	private $debug = false;
	
	public function __construct($arr){
		$this->charset = SYS_CHARSET;
		$this->smtp['host'] = MAIL_SMTPSERV;
		$this->smtp['port'] = MAIL_SMTPPORT;
		$this->smtp['user'] = MAIL_SMTPUSER;
		$this->smtp['pass'] = MAIL_SMTPPASS;
		$this->sender = MAIL_FROMMAIL;
		$this->mailer = strtolower(MAIL_SENDTYPE);
		return true;
	}

	public function add($mail, $type = 'to'){
		$arr = explode('|', preg_replace("/[\r\n]+/", '', $mail));
		$this->$type = array('addr'=>trim($arr[0]), 'name'=>trim($arr[1]));
	}
	
	public function send(){
		$send = $this->mailer .'_send';
		$this->$send();
	}
	
	private function mail_send(){
		if($this->sender){
			$param = "-oi -f {$this->sender}";
		}else{
			$param = '';
		}
  		$head = "Content-Type: {$this->content_type};". $this->EOL ." charset=\"{$this->charset}\"". $this->EOL;
    	$head .= "Reply-to: ". $this->from['addr']. $this->EOL;
    	$head .= "Content-Transfer-Encoding: {$this->encoding} ". $this->EOL;
		return mail($this->to['addr'], $this->encode_head($this->subject), $this->encode_body($this->body), $head, $param);
	}

	private function smtp_send(){
		$mail = $this->sender ? $this->sender : $this->from['addr'];
		$arr = explode('@', $mail);
		$this->smtp['helo'] = $arr[1];
	
		if(!$this->smtp_sockopen()) return false;
		if(!$this->smtp_putcmd("HELO", $this->smtp['helo'])) return false;
		if($this->smtp['user'] && $this->smtp['pass']){
			if(!$this->smtp_putcmd("AUTH LOGIN", base64_encode($this->smtp['user']))) return false;
			if(!$this->smtp_putcmd("", base64_encode($this->smtp['pass']))) return false;
		}
		if(!$this->smtp_putcmd("MAIL", "FROM:<". $this->from['addr'] .">")) return false;
		$this->smtp_putcmd("RCPT", "TO:<". $this->to['addr'] .">");
		if(!$this->smtp_putcmd("DATA")) return false;
		fwrite($this->sock, $this->head() . $this->encode_body($this->body));
		fwrite($this->sock, $this->EOL .'.'. $this->EOL);
		fwrite($this->sock, "QUIT" . $this->EOL);
		fclose($this->sock);
		return true;
	}

	private function smtp_sockopen(){
		$this->sock = fsockopen($this->smtp['host'], $this->smtp['port'], $errno, $errstr, $this->smtp['timeout']);
		if($this->sock && $this->smtp_ok()){return true;}else{return false;}
	}
	
	private function smtp_ok(){
		$response = trim(fgets($this->sock, 512));
		if($this->debug) echo "$response<br>";
		return preg_match("/^[23]/", $response);
	}

	private function smtp_putcmd($cmd, $arg = ''){
		$cmd = "$cmd $arg";
		if($this->debug) echo htmlspecialchars($cmd).'<br>';
		fwrite($this->sock, $cmd . $this->EOL);
		$status = $this->smtp_ok();
		return $status;
	}

	private function head(){
		list($msec, $sec) = explode(' ', microtime());
		$message_ID = date('YmdHis', $sec) .'.'. ($msec*1000000) . strstr($this->from['addr'], '@');

		$str  = "MIME-Version: 1.0 ". $this->EOL;
		$str .= "Return-Path: ". $this->from['addr']. $this->EOL;
		$str .= "From: ". $this->address($this->from). $this->EOL;
		$str .= "To: ". $this->address($this->to). $this->EOL;
		$str .= "Reply-to: ". $this->from['addr']. $this->EOL;
 		$str .= "Subject: ". $this->encode_head($this->subject). $this->EOL;
  		$str .= "Date: ". date('r') . $this->EOL;
  		$str .= "X-Priority: ". $this->priority. $this->EOL;
  		$str .= "Message-ID: $message_ID ". $this->EOL;
        $str .= "Content-Type: {$this->content_type};". $this->EOL ." charset=\"{$this->charset}\"". $this->EOL;
        $str .= "Content-Transfer-Encoding: {$this->encoding} ". $this->EOL;
        $str .= $this->EOL . $this->EOL;
        return $str;
    }

	private function address($arr){
		return $this->encode_head($arr['name']) .' <'. $arr['addr'] .'>';
	}
	
	private function encode_head($str){
		return '=?'. $this->charset .'?B?'. base64_encode($str) .'?=';
	}
	
	private function encode_body($str){
		return base64_encode($str);
	}
}
?>