<?php
/* web@all CMS, Copyright (C) webatall.org, Author:poetbi@gmail.com, License: http://webatall.org/license.php */
function get_date($time = 0, $format = SYS_LONG_DATE){
	if(!$time) $time = time();
	$str = strftime($format, $time);
	if(function_exists('mb_check_encoding') && !mb_check_encoding($str, SYS_CHARSET)){
		preg_match("/[\w-]+/", $_SERVER["HTTP_ACCEPT_CHARSET"], $arr);
		if(function_exists('iconv')){
			$str = iconv($arr[0], SYS_CHARSET, $str);
		}else{
			$str = mb_convert_encoding($str, SYS_CHARSET, $arr[0]);
		}
	}
	return $str;
}

function get_time($time = 0, $format = 'Y-m-d'){
	if(!$time) $time = time();
	$str = strtotime(date($format, $time), $time);
	return $str;
}

function get_ip(){
	switch(true){
		case $_SERVER['HTTP_CLIENT_IP']      : $ip = $_SERVER['HTTP_CLIENT_IP']; break;
		case $_SERVER['HTTP_X_FORWARDED_FOR']: $ip = $_SERVER['HTTP_X_FORWARDED_FOR']; break;
		case $_SERVER['REMOTE_ADDR']         : $ip = $_SERVER['REMOTE_ADDR']; break;
		default                              : $ip = 'Unknown';
	}
	if(!preg_match("/^[\w\:\.]{7,39}$/", $ip)) $ip = 'Unknown';
	return $ip;
}

function get_size($size, $start = 'B'){
    if(!$size) return 0;
	$units = array('B'=>0, 'KB'=>1, 'MB'=>2, 'GB'=>3, 'TB'=>4);
	$start_i = $units[$start] + 1;
	foreach($units as $k => $v){
		if($v < $start_i) continue;
		if($size < 1024){
			if(!$unit) $unit = 'B';
			break;
		}else{
			$size = $size / 1024;
			$unit = $k;
		}
	}
    return round($size, 2) .' '. $unit;
}

function get_prefer($arr, $type = 1){
	$arr = array_unique($arr);
	foreach($arr as $k=>$v){
		if($v != ''){
			if($type == -1) $v = $k;
			return $v;
		}
	}
}

function get_text($str, $setlang = ''){
	$arr = unserialize($str);
	if(!is_array($arr)) return $str;
	if($setlang) return $arr[$setlang];

	$lngs = array($GLOBALS['wa']->env['lng'], SYS_LANGUAGE, key($arr));
	foreach($lngs as $lng){if($arr[$lng] != '') return $arr[$lng];}
}

function randstr($len, $type='number_lower_upper_sign'){
	$arr = array(
		'number' => '0123456789',
		'lower'  => 'abcdefghijklmnopqrstuvwxwz',
		'upper'  => 'ABCDEFGHIJKLMNOPQRSTUVWXWZ',
		'sign'   => '~@#$%^&*()_-+=|[]{};:,.<>?'
	);
	$types = explode('_', $type);
	foreach($types as $v){$str .= $arr[$v];}
	$max = strlen($str) - 1;
	for($i=0; $i<$len; $i++){$rand .= $str[mt_rand(0, $max)];}
	return $rand;
}

function cut_str($str, $len, $add = false){
	$fun = function_exists('iconv_substr') ? 'iconv_substr' : 'mb_substr';
	if(function_exists($fun)){
		$str = $fun($str, 0, $len, SYS_CHARSET);
	}else{
		$strlen = strlen($str);
		if($strlen <= $len) return $str;
		$len *= 2;
		if(strtolower(SYS_CHARSET) == 'utf-8'){
			$n = $tn = $noc = 0;
			while($n < $strlen){
				$t = ord($str[$n]);
				if($t <= 10 || (32 <= $t && $t <= 126)){
					$tn = 1; $n++; $noc++;
				}else if(194 <= $t && $t <= 223){
					$tn = 2; $n += 2; $noc += 2;
				}else if(224 <= $t && $t < 239){
					$tn = 3; $n += 3; $noc += 2;
				}else if(240 <= $t && $t <= 247){
					$tn = 4; $n += 4; $noc += 2;
				}else if(248 <= $t && $t <= 251){
					$tn = 5; $n += 5; $noc += 2;
				}else if($t == 252 || $t == 253){
					$tn = 6; $n += 6; $noc += 2;
				}else{
					$n++;
				}
				if($noc >= $len) break;
			}
			if($noc > $len) $n -= $tn;
			$str = substr($str, 0, $n);
		}else{
			for($i = 0; $i < $len; $i++){
				$strcut .= ord($str[$i]) > 127 ? $str[$i].$str[++$i] : $str[$i];
			}
			$str = $strcut;
		}
	}
	$dot = $add ? '...' : '';
	return $str.$dot;
}

function xml2arr($data, $root = 'webatall'){
	$data = str_replace('&', '#26', trim($data));
	$arr = array();
	$path = array(0 => '$arr');
	$parser = xml_parser_create(SYS_CHARSET);   
    xml_parser_set_option($parser, XML_OPTION_CASE_FOLDING, false);
    xml_parser_set_option($parser, XML_OPTION_SKIP_WHITE, true);
    if(xml_parse_into_struct($parser, $data, $vals) !== 1) $GLOBALS['wa']->setmsg('ERROR_023', xml_error_string(xml_get_error_code($parser)) .'@@@'. xml_get_current_line_number($parser));
	xml_parser_free($parser);
	foreach($vals as $v){
		$v['value'] = str_replace('#26', '&', $v['value']);
		$path[$v['level']] = $path[$v['level'] - 1] .'[\''. $v['tag'] .'\']';
		if($v['type'] == 'complete') eval($path[$v['level']] ." = htmlspecialchars_decode(\$v['value']);");
		if(array_key_exists('attributes', $v)){
			$key = $path[$v['level'] - 1] .'[\''. $v['tag'] .'_attr\']';
			foreach($v['attributes'] as $ak=>$av){$v['attributes'][$ak] = htmlspecialchars_decode($av);}
			eval($key ." = \$v['attributes'];");
		}
	}
	if($root) $arr = $arr[$root];
	return $arr;
}

function arr2xml($data, $level = 0){
	if($level == 0) $xml = '<?xml version="1.0" encoding="'. SYS_CHARSET .'"?>';
	$indent = PHP_EOL . str_repeat("\t", $level);
	foreach($data as $key=>$val){
		$res = preg_match("/^(\w+)_attr$/", $key, $keys);
		if($res){
			if(array_key_exists($keys[1], $data)) continue;
		}else{
			$attributes = '';
			if(array_key_exists("{$key}_attr", $data)){
				foreach($data["{$key}_attr"] as $k=>$v){$attributes .= ' '. $k .'="'. htmlspecialchars($v) .'"';}
			}
		}
		if(is_array($val)){
			$xml .= "$indent<{$key}{$attributes}>". arr2xml($val, $level+1) ."$indent</$key>";
		}else{
			if(preg_match("/[\"'&<>]/", $val)) $val = "<![CDATA[$val]]>";
			$xml .= "$indent<{$key}{$attributes}>$val</$key>";
		}
	}
	return $xml;
}

function block_tags($str){
	$tags = preg_replace("/\s+/", '', SYS_BLOCKED_TAGS);
	$str = preg_replace("/<(\/?(". $tags .")[^>]*)>/i", '&lt;\\1&gt;', $str);
	$str = preg_replace("/ on([a-zA-Z]+)\s*=/i", ' on\\1&#61;', $str);
	$str = preg_replace("/javascript(:|&#58;)/i", 'javascript :', $str);
	return $str;
}

function split_content($content, $page){
	$arr = preg_split('/<hr style="page-break-after:always;" class=".*?" title="([\s\S]*?)" \/>/i', $content, -1, PREG_SPLIT_DELIM_CAPTURE);
	$len = count($arr);
	if($len > 1){
		$start = 1;
		if(str_replace('&nbsp;', '', trim(strip_tags($arr[0]))) != ''){
			$page -= 1;
			$start -= 2;
		}
		for($i=$start; $i<$len; $i=$i+2){
			$pages[] = trim($arr[$i]);
		}
		$content = '<h3 class="page_break">'.$arr[$page * 2 - 1].'</h3>'.$arr[$page * 2];
	}
	$arr = array();
	$arr['pages'] = $pages;
	$arr['content'] = $content;
	return $arr;
}

function get_subcid($cid){
global $db;
	if(!$cid) return 0;
	$str = $cid;
	$res = $db->query("SELECT category_id FROM @db_category WHERE parentid IN ($cid) AND status > 0 AND redirect = ''");
	while($rs = $db->row($res)){
		if($cid = get_subcid($rs['category_id'])) $str .= ','. $cid;
	}
	return $str;
}
?>