<?php
/* web@all CMS, Copyright (C) webatall.org, Author:poetbi@gmail.com, License: http://webatall.org/license.php */
switch(true){
	case preg_match("/\/file\/.+/", $_SERVER['REQUEST_URI']) :
		require(dirname(__FILE__) . '/inc/config.php');
		if($_SERVER['UNENCODED_URL']){
			$file = DIR . $_SERVER['UNENCODED_URL'];
		}else{
			$file = DIR . $_SERVER['REQUEST_URI'];
		}
		if(file_exists($file)){
			if(preg_match("/\.(jpg|gif|bmp|png)$/", $file)){
				$mime_type = 'image/gif';
			}else{
				$mime_type = 'application/force-download';
				$filename = basename($file);
				header('Content-Disposition: attachment; filename="['. SYS_ROOTNAME .']'. $filename .'"');
			}
			set_time_limit(0);
			header("X-Powered-By: web@all CMS (http://webatall.org)");
			header("Content-type: $mime_type");
			readfile($file);
		}else{
			require(dirname(__FILE__) . '/inc/header.php');
			_404();
		}
		break;

	case preg_match("/index\.php$/", $_SERVER['REQUEST_URI']) || $_SERVER['REQUEST_URI'] == '/' :
		require(dirname(__FILE__) . '/inc/header.php');
		$tpl = 'index.htm';
		$ttl = SYS_CACHE_INDEX;
		$tag = "{$wa->env['lng']}_index";
		$wa->env['cid'] = 0;
		_200();
		break;

	case isset($_GET['w']) :
	case preg_match("/-(\d+)-(\d+)-(\d+)$/", $_SERVER['REQUEST_URI'], $a) :
		require(dirname(__FILE__) . '/inc/header.php');
		if(SYS_URL_REWRITE){
			$wa->env['cid'] = $a[1];
			$wa->env['pid'] = $a[2];
			$wa->env['page'] = $a[3] < 1 ? 1 : $a[3];
		}else{
			$wa->env['cid'] = $wa->v('w');
			$wa->env['pid'] = $wa->v('a');
		}
		if($wa->env['cid'] <= 0 || $wa->env['pid'] < 0) _404();
		$wa->check('basic.access', $wa->env['cid']);
		$cg = new mod_category();
		$cat = $cg->get(array('id'=>$wa->env['cid']));
		if($cat){
			if($wa->env['pid']){
				$tpl = $cat['content_tpl'] ? $cat['content_tpl'] : 'article_content.htm';
				$ttl = $cat['content_cache'] < 0 ? SYS_CACHE_CONTENT : $cat['content_cache'];
			}else{
				$tpl = $cat['category_tpl'] ? $cat['category_tpl'] : 'article_listing.htm';
				$ttl = $cat['category_cache'] < 0 ? SYS_CACHE_CATEGORY : $cat['category_cache'];
			}
			$tag = "{$wa->env['cid']}/{$wa->env['pid']}/{$wa->env['lng']}_{$wa->env['page']}";
			_200();
		}else{
			_404();
		}
		break;
	
	default :
		require(dirname(__FILE__) . '/inc/header.php');
		_404();
}

function _404(){
global $wa, $db;
	$wa->env['cid'] = 0;
	header("HTTP/1.1 404 Not Found");
	header("Status: 404 Not Found");
	header("X-Powered-By: web@all CMS (http://webatall.org)");
	header("X-Robots-Tag: noindex, nofollow, noarchive");
	$cache = DIR ."/dat/cache_web/{$wa->env['lng']}_index";
	if(SYS_CACHE_INDEX > 0 && file_exists($cache)){
		require($cache);
	}else{
		require($wa->tpl('/tpl/'. SYS_TEMPLATE .'/index.htm'));
	}
	exit;
}

function _200(){
global $wa, $db, $tpl, $ttl, $tag, $cg, $cat;
	if(!WA_IN_DEV_MODE && $ttl > 0){
		$ttl *= 3600;
		$cache = DIR ."/dat/cache_web/$tag";
		$time = filemtime($cache);
		$left = $time + $ttl - time();
		if($left < 0){
			require($wa->tpl('/tpl/'. SYS_TEMPLATE ."/$tpl"));
			$create_path = dirname($cache);
			if(!file_exists($create_path)) make_dir($create_path);
			file_put_contents($cache, $wa->zip(ob_get_clean()));
			$time = filemtime($cache);
			$left = $time + $ttl - time();
		}
		if(preg_match("/Windows|Mac|Linux|FreeBSD|Sun/i", $_SERVER['HTTP_USER_AGENT'])){
			header('Cache-Control: public, max-age='. $left);
			header('Etag: '. md5($tag));
			header('Last-Modified: '. gmdate('D, d M Y H:i:s', $time) .' GMT');
			header('Expires: '. gmdate('D, d M Y H:i:s', $time+$ttl) .' GMT');
		}
		require($cache);
	}else{
		require($wa->tpl('/tpl/'. SYS_TEMPLATE ."/$tpl"));
	}
}
?>