<?php
/* web@all CMS, Copyright (C) webatall.org, Author:poetbi@gmail.com, License: http://webatall.org/license.php */
class mod_article extends basemod{
	protected $tabs = array(
		'@db_article'      => 'A',
		'@db_article_lang' => 'B',
		'@db_category'     => 'C'
	);
	protected $search = array(
		'title' =>'A.title',
		'status' =>'A.status',
		'content_key' =>'A.content_key',
		'member_id' =>'A.member_id',
		'author' =>'A.author',
		'timeadd' => 'A.timeadd',
		'category' =>'A.category_id'		
	);
	protected $prikey = 'article_id';

	public function __construct(){
		parent::__construct();
	}

	public function get($args){
		$this->args = $args;
		$sql['field'] = 'A.title AS lngs, A.*, B.*';
		$sql['table'] = '@db_article A, @db_article_lang B';
		$sql['where'][] = "B.article_id = A.article_id";
		if($args['setlang']){
			$sql['where']['lang'] = "B.lang = '{$args['setlang']}'";
		}else if(SYS_MULTI_LANGUAGE){
			$a = parent::a($args['id'], 'title');
			$a = unserialize($a['title']);
			$a = array($this->wa->env['lng'] => $a[$this->wa->env['lng']], SYS_LANGUAGE => $a[SYS_LANGUAGE]);
			$lang = get_prefer($a, -1);
			if($lang) $sql['where']['lang'] = "B.lang = '$lang'";
		}
		$rs = parent::_get($sql, 'inc_rs_get');
		if($args['setpage'] > 0){
			$arr = split_content($rs['content'], $args['setpage']);
			$rs = array_merge($rs, $arr);
		}
		$rs['lngs'] = array_keys(unserialize($rs['lngs']));
		$arr = explode(',', $rs['meta_keywords']);
		if($arr[0]){
			$rs['keywords'] = trim($arr[0]);
		}else{
			$rs['keywords'] = cut_str($rs['title'], 3);
		}
		return $rs;
	}

	public function gets($args){
		$this->args = $args;
		$sql['field'] = 'A.article_id, A.category_id, A.status, A.title, A.content_key, A.member_id, A.author, A.thumbs, A.hits, A.timeadd';
		$sql['table'] = '@db_article A';
		if($args['setlang']){
			$sql['table'] .= ', @db_article_lang B';
			$sql['where']['ab'] = 'B.article_id = A.article_id';
			$sql['where'][] = "B.lang = '{$args['setlang']}'";
		}
		
		$c = explode(',', $args['category'] .','. $this->wa->me['cat_limit']);
		$c = array_filter($c);
		$categoies = implode(',', array_unique($c));
		if($categoies){
			$sql['where'][] = "A.category_id IN ($categoies)";
			unset($this->args['category']);
		}

		switch($args['flag']){
			case 'category':
			$sql['field'] .= ', C.category, C.category_key';
			$sql['table'] .= ', @db_category C';
			$sql['where']['ac'] = 'C.category_id = A.category_id';
			break;

			case 'all':
			$sql['field'] .= ', B.*, C.category, C.category_key';
			$sql['table'] = '@db_article A, @db_article_lang B, @db_category C';
			$sql['where']['ab'] = 'B.article_id = A.article_id';
			$sql['where']['ac'] = 'C.category_id = A.category_id';
			break;
		}
		return parent::_gets($sql, 'inc_rs_gets');
	}

	public function mem_add(){
		$_POST['status'] = 0;
		$_POST['content'] = block_tags($_POST['content']);
		$res = $this->sys_add();
		return $res;
	}

	public function mem_edit(){
		$_POST['status'] = 0;
		$_POST['member_id'] = $this->wa->me['member_id'];
		$_POST['content'] = block_tags($_POST['content']);
		$res = $this->sys_edit();
		return $res;
	}

	public function mem_lang(){
		extract($this->vars());
		$id = $this->wa->env['id'];
		if(!$lang) $this->wa->setmsg('ERROR_052', "{$this->wa->lng('sys.field_lang')}(lang)");

		$rs = parent::a($id, 'title');
		$arr = unserialize($rs['title']);
		$arr[$lang] = $title;
		$sql['field']['title'] = serialize($arr);
		$sql['field']['status'] = 0;
		$sql['field']['files'] = $files;
		$sql['where'] = "article_id = '$id'";
		parent::_edit($sql, $title);

		$sql = array();
		$sql['table'] = '@db_article_lang';
		$sql['field']['title'] = $title;
		$sql['field']['content'] = block_tags($content);
		$sql['field']['translator'] = $translator;
		$sql['field']['meta_keywords'] = strip_tags($meta_keywords);
		$sql['field']['meta_description'] = strip_tags($meta_description);
		$sql['field']['options'] = $options;
		$sql['field']['timeedit'] = time();
		$sql['field']['article_id'] = $id;
		$sql['field']['lang'] = $lang;
		return parent::_add($sql, $title);
	}

	public function sys_add(){
		extract($this->vars());
		if(!$lang) $lang = SYS_LANGUAGE;
		if($thumbs && !preg_match("/^http:\/\//i", $thumbs)){
			$img = new do_image();
			$thumbs = $img->thumbs(DIR . $thumbs);
			if(strpos($files, $thumbs) === false) $files .= "$thumbs@"; 
		}

		$sql['field']['title'] = serialize(array($lang => $title));
		$sql['field']['content_key'] = alias($content_key);
		$sql['field']['category_id'] = $category_id;
		$sql['field']['status'] = $status;
		$sql['field']['member_id'] = $this->wa->me['member_id'];
		$sql['field']['thumbs'] = $thumbs;
		$sql['field']['author'] = $author;
		$sql['field']['copyright'] = $copyright;
		$sql['field']['robots'] = implode(',', $robots);
		$sql['field']['files'] = $files;	
		$sql['field']['timeadd'] = time();
		$res = parent::_add($sql, $title);
		
		if($this->lastid){
			$sql = array();
			$sql['table'] = '@db_article_lang';
			$sql['field']['article_id'] = $this->lastid;
			$sql['field']['lang'] = $lang;
			$sql['field']['title'] = $title;
			$sql['field']['content'] = $content;
			$sql['field']['commentid'] = parent::unique('commentid');
			$sql['field']['meta_keywords'] = strip_tags($meta_keywords);
			$sql['field']['meta_description'] = strip_tags($meta_description);
			$sql['field']['options'] = $options;
			$sql['field']['timeedit'] = time();
			parent::_add($sql);
		}
		return $res;
	}

	public function sys_edit(){
		extract($this->vars());
		$id = $this->wa->env['id'];
		parent::clear_web($id);
		if($member_id){
			$rs = parent::a($id, 'member_id');
			if($member_id != $rs['member_id']) return;
		}
		if(!$lang) $lang = SYS_LANGUAGE;
		if($thumbs && !preg_match("/^http:\/\//i", $thumbs)){
			$img = new do_image();
			$thumbs = $img->thumbs(DIR . $thumbs);
			if(strpos($files, $thumbs) === false) $files .= "$thumbs@"; 
		}

		$rs = parent::a($id, 'title');
		$arr = unserialize($rs['title']);
		$arr[$lang] = $title;

		$sql['field']['title'] = serialize($arr);
		$sql['field']['content_key'] = alias($content_key);
		$sql['field']['category_id'] = $category_id;
		$sql['field']['status'] = $status;
		$sql['field']['thumbs'] = $thumbs;
		$sql['field']['author'] = $author;
		$sql['field']['copyright'] = $copyright;
		$sql['field']['robots'] = implode(',', $robots);
		$sql['field']['files'] = $files;	
		$sql['where'][] = "article_id = '$id'";
		$res = parent::_edit($sql, $title);

		$sql = array();
		$sql['table'] = '@db_article_lang';
		$sql['where'][] = "article_id = '$id'";
		$sql['where'][] = "lang = '$lang'";
		$sql['field']['title'] = $title;
		$sql['field']['content'] = $content;
		$sql['field']['meta_keywords'] = strip_tags($meta_keywords);
		$sql['field']['meta_description'] = strip_tags($meta_description);
		$sql['field']['options'] = $options;
		$sql['field']['timeedit'] = time();
		parent::_edit($sql, $title);
		return $res;
	}

	public function sys_lang(){
		extract($this->vars());
		$id = $this->wa->env['id'];
		parent::clear_web($id);
		$isdel = $this->wa->v('isdel');
		if(!$lang) $this->wa->setmsg('ERROR_052', "{$this->wa->lng('sys.field_lang')}(lang)");

		$rs = parent::a($id, 'title');
		$arr = unserialize($rs['title']);
		$isadd = empty($arr[$lang]) ? true : false;
		if($isdel){
			unset($arr[$lang]);
		}else{
			$arr[$lang] = $title;
		}
		$sql['field']['title'] = serialize($arr);
		$sql['field']['files'] = $files;
		$sql['where'] = "article_id = '$id'";
		parent::_edit($sql, $title);

		$sql = array();
		if($isdel){
			$sql['table'] = '@db_article_lang';
			$sql['where'][] = "article_id = '$id'";
			$sql['where'][] = "lang = '$lang'";
			$res = parent::_del($sql, $title);
		}else{
			$sql['table'] = '@db_article_lang';
			$sql['field']['title'] = $title;
			$sql['field']['content'] = $content;
			$sql['field']['translator'] = $translator;
			$sql['field']['meta_keywords'] = strip_tags($meta_keywords);
			$sql['field']['meta_description'] = strip_tags($meta_description);
			$sql['field']['options'] = $options;
			$sql['field']['timeedit'] = time();
			if($isadd){
				$sql['field']['article_id'] = $id;
				$sql['field']['lang'] = $lang;
				$res = parent::_add($sql, $title);
			}else{
				$sql['where'][] = "article_id = '$id'";
				$sql['where'][] = "lang = '$lang'";
				$res = parent::_edit($sql, $title);
			}
		}
		return $res;
	}

	public function sys_del(){
		$id = $this->wa->env['id'];
		parent::clear_web($id);
		$sql['field']['status'] = -1;
		$sql['where'] = "article_id = '$id'";
		parent::_edit($sql);
		$arr['key'] = 'INFO_DEL';
		$arr['msg'] = "@@@(article_id = $id)";
		return $arr;
	}

	public function sys_clear(){
		$id = $this->wa->env['id'];
		if($id){
			$rs = parent::a($id, 'title,member_id,files');
			$arr = explode('@', $rs['files']);
			foreach($arr as $file){
				if(strpos($file, "/file/{$rs['member_id']}/") === 0) unlink(DIR . $file);
			}

			$sql['where'] = "article_id = '$id'";
			$sql['table'] = '@db_article_lang';
			parent::_del($sql);
			$sql['table'] = '@db_article';
			return parent::_del($sql, get_text($rs['title']));
		}else{
			$this->wa->showMSG = false;
			$rss = $this->gets(array('sql'=>'A.status = -1', 'field'=>'article_id,title,member_id,files'));
			foreach($rss as $rs){
				$arr = explode('@', $rs['files']);
				foreach($arr as $file){
					if(strpos($file, "/file/{$rs['member_id']}/") === 0) unlink(DIR . $file);
				}

				$sql['where'] = "article_id = '{$rs['article_id']}'";
				$sql['table'] = '@db_article_lang';
				parent::_del($sql);
				$sql['table'] = '@db_article';
				$res = parent::_del($sql, get_text($rs['title']));
				$this->wa->setmsg($res['key'], $res['msg']);
			}
		}
	}

	public function sys_bat(){
		$ids = $this->wa->v('selectme', 'system_int');
		if(!$ids) $this->wa->setmsg('ERROR_050');
		$str = implode(',', $ids);
		$batcmd = $this->wa->v('batcmd');

		$this->wa->showMSG = false;
		switch($batcmd){
			case 'delete' :
				$sql['field']['status'] = -1;
				$sql['where'] = "article_id IN ($str)";
				parent::_edit($sql);
				$text = $this->wa->lng('all.button_delete');
				break;

			case 'clear' :
				foreach($ids as $id){
					$this->wa->env['id'] = $id;
					$res = $this->sys_clear();
					$this->wa->setmsg($res['key'], $res['msg']);
				}
				$text = $this->wa->lng('all.button_clear');
				break;

		}

		$arr['msg'] = "'$text'";
		return $arr;
	}

	protected function inc_rs_gets($rs){
		$rs['title'] = get_text($rs['title'], $this->args['setlang']);
		$content_key = str_replace('-', '', $rs['content_key']) ? $rs['content_key'] : 'article';
		$rs['content_url'] = content_url($rs['category_id'], $rs['article_id'], $content_key);
		if($this->args['flag'] == 'category'){
			$rs['category'] = get_text($rs['category']);
			$rs['category_url'] = category_url($rs['category_id'], $rs['category_key']);
		}
		if($this->args['titlelen'] > 0){
			$rs['title'] = cut_str($rs['title'], $this->args['titlelen'], $this->args['titledot']);
		}
		return $rs;
	}

	protected function inc_rs_get($rs){
		$arr = explode("\n", $rs['options']);
		if(is_array($arr)){
			foreach($arr as $option){
				$subarr = explode('=', $option);
				$key = trim($subarr[0]);
				if($key && !array_key_exists($key, $rs)) $rs[$key] = trim($subarr[1]);
			}
		}
		return $rs;
	}

	protected function vars(){
		$vars = array(
			array('title', 'system_req'),
			array('content', 'system_req'),
			'status',
			'category_id',
			'member_id',
			'content_key',
			'thumbs',
			'author',
			'copyright',
			'robots',
			'files',
			'translator',
			'meta_keywords',
			'meta_description',
			'options',
			'lang'
		);
		return parent::vars($vars);
	}
}
?>