<?php
/* web@all CMS, Copyright (C) webatall.org, Author:poetbi@gmail.com, License: http://webatall.org/license.php */
class mod_category extends basemod{
	protected $tabs = array(
		'@db_category'      => 'A',
		'@db_category_lang' => 'B'
	);
	protected $search = array();
	protected $prikey = 'category_id';
	private $clear_tree_cache = 0;

	public function __construct(){
		parent::__construct();
	}

	public function __destruct(){
		if($this->clear_tree_cache) clear_dir(DIR .'/dat/cache_sys/category');
	}

	public function get($args){
		$this->args = $args;
		$sql['table'] = '@db_category A, @db_category_lang B';
		$sql['where'][] = "B.category_id = A.category_id";
		if($args['setlang']){
			$sql['where']['lang'] = "B.lang = '{$args['setlang']}'";
		}else if(SYS_MULTI_LANGUAGE){
			$a = parent::a($args['id'], 'category');
			$a = unserialize($a['category']);
			$a = array($this->wa->env['lng'] => $a[$this->wa->env['lng']], SYS_LANGUAGE => $a[SYS_LANGUAGE]);
			$lang = get_prefer($a, -1);
			if($lang) $sql['where']['lang'] = "B.lang = '$lang'";
		}
		return parent::_get($sql, 'inc_rs_get');
	}

	public function gets($args){
		$this->args = $args;
		$sql['field'] = 'A.category_id, A.parentid, A.status, A.category, A.category_key, A.ordernum, A.redirect';
		$sql['table'] = '@db_category A';
		if($args['setlang']){
			$sql['table'] .= ', @db_category_lang B';
			$sql['where'][] = 'B.category_id = A.category_id';
			$sql['where'][] = "B.lang = '{$args['setlang']}'";
		}
		return parent::_gets($sql, 'inc_rs_gets');
	}

	public function sys_add(){	
		extract($this->vars());
		$categories = explode("\n", $category);
		$category_keys = explode("\n", $category_key);
		if(!$lang) $lang = SYS_LANGUAGE;
		$this->wa->showMSG = false;
		foreach($categories as $i=>$category){
			$category = trim($category);
			if($category == '') continue;
			$category_key = $category_keys[$i];

			$sql = array();
			$sql['field']['category'] = serialize(array($lang => $category));
			$sql['field']['category_key'] = alias($category_key);
			$sql['field']['parentid'] = $parentid;
			$sql['field']['status'] = $status;
			$sql['field']['ordernum'] = $ordernum;
			$sql['field']['category_cache'] = $category_cache;
			$sql['field']['content_cache'] = $content_cache;
			$sql['field']['redirect'] = $redirect;
			$res = parent::_add($sql, $category);
			
			if($this->lastid){
				$sql = array();
				$sql['table'] = '@db_category_lang';
				$sql['field']['category_id'] = $this->lastid;
				$sql['field']['lang'] = $lang;
				$sql['field']['category'] = $category;
				$sql['field']['category_tpl'] = $category_tpl;
				$sql['field']['content_tpl'] = $content_tpl;
				$sql['field']['meta_keywords'] = strip_tags($meta_keywords);
				$sql['field']['meta_description'] = strip_tags($meta_description);
				$sql['field']['options'] = $options;
				parent::_add($sql);

				$this->wa->setmsg($res['key'], $res['msg']);
			}
		}
		$this->clear_tree_cache = 1;
		return array();
	}

	public function sys_edit(){
		extract($this->vars());
		$id = $this->wa->env['id'];
		if(!$lang) $lang = SYS_LANGUAGE;

		$rs = parent::a($id, 'category');
		$arr = unserialize($rs['category']);
		$arr[$lang] = $category;

		$sql['field']['category'] = serialize($arr);
		$sql['field']['category_key'] = alias($category_key);
		$sql['field']['parentid'] = $parentid;
		$sql['field']['status'] = $status;
		$sql['field']['ordernum'] = $ordernum;
		$sql['field']['category_cache'] = $category_cache;
		$sql['field']['content_cache'] = $content_cache;
		$sql['field']['redirect'] = $redirect;
		$sql['where'][] = "category_id = '$id'";
		$res = parent::_edit($sql, $category);

		$sql = array();
		$sql['table'] = '@db_category_lang';
		$sql['where'][] = "category_id = '$id'";
		$sql['where'][] = "lang = '$lang'";
		$sql['field']['category'] = $category;
		$sql['field']['category_tpl'] = $category_tpl;
		$sql['field']['content_tpl'] = $content_tpl;
		$sql['field']['meta_keywords'] = strip_tags($meta_keywords);
		$sql['field']['meta_description'] = strip_tags($meta_description);
		$sql['field']['options'] = $options;
		parent::_edit($sql, $category);

		$this->clear_tree_cache = 1;
		return $res;
	}

	public function sys_lang(){
		extract($this->vars());
		$id = $this->wa->env['id'];
		$isdel = $this->wa->v('isdel');
		if(!$lang) $this->wa->setmsg('ERROR_052', "{$this->wa->lng('sys.field_lang')}(lang)");

		$rs = parent::a($id, 'category');
		$arr = unserialize($rs['category']);
		$isadd = empty($arr[$lang]) ? true : false;
		if($isdel){
			unset($arr[$lang]);
		}else{
			$arr[$lang] = $category;
		}
		$sql['field']['category'] = serialize($arr);
		$sql['where'] = "category_id = '$id'";
		parent::_edit($sql, $category);

		$sql = array();
		if($isdel){
			$sql['table'] = '@db_category_lang';
			$sql['where'][] = "category_id = '$id'";
			$sql['where'][] = "lang = '$lang'";
			$res = parent::_del($sql, $category);
		}else{
			$sql['table'] = '@db_category_lang';
			$sql['field']['category'] = $category;
			$sql['field']['category_tpl'] = $category_tpl;
			$sql['field']['content_tpl'] = $content_tpl;
			$sql['field']['meta_keywords'] = strip_tags($meta_keywords);
			$sql['field']['meta_description'] = strip_tags($meta_description);
			$sql['field']['options'] = $options;
			if($isadd){
				$sql['field']['category_id'] = $id;
				$sql['field']['lang'] = $lang;
				$res = parent::_add($sql, $category);
			}else{
				$sql['where'][] = "category_id = '$id'";
				$sql['where'][] = "lang = '$lang'";
				$res = parent::_edit($sql, $category);
			}
		}

		$this->clear_tree_cache = 1;
		return $res;
	}

	public function sys_del(){
		$id = $this->wa->env['id'];
		$rs = parent::a($id, 'parentid,category');
		if($rs){
			$sql['field']['parentid'] = $rs['parentid'];
			$sql['where'] = "parentid = '$id'";
			parent::_edit($sql);

			$this->clear_tree_cache = 1;
			$sql = array();
			$sql['where'] = "category_id = '$id'";
			$sql['table'] = '@db_category_lang';
			parent::_del($sql);
			$sql['table'] = '@db_category';
			return parent::_del($sql, get_text($rs['category']));
		}else{
			$arr['key'] = 'INFO_FAIL';
			$arr['msg'] = "@@@(category_id = $id)";
			return $arr;
		}
	}

	public function sys_bat(){
		$ids = $this->wa->v('selectme', 'system_int');
		if(!$ids) $this->wa->setmsg('ERROR_050');
		$str = implode(',', $ids);
		$batcmd = $this->wa->v('batcmd');

		$this->wa->showMSG = false;
		switch($batcmd){
			case 'sort' :
				$ordernum = $this->wa->v('ordernum');				
				foreach($ids as $id){
					$sql['field']['ordernum'] = $ordernum[$id];
					$sql['where'] = "category_id = '$id'";
					$res = parent::_edit($sql);
					$this->wa->setmsg($res['key'], $res['msg']);
				}
				$text = $this->wa->lng('category.sort');
				break;

		}

		$arr['msg'] = "'$text'";
		return $arr;
	}

	protected function inc_rs_get($rs){
		$arr = explode("\n", $rs['options']);
		if(is_array($arr)){
			foreach($arr as $option){
				$subarr = explode('=', $option);
				$key = trim($subarr[0]);
				if($key && !array_key_exists($key, $rs)) $rs[$key] = trim($subarr[1]);
			}
		}
		return $rs;
	}

	protected function inc_rs_gets($rs){
		$rs['category'] = get_text($rs['category'], $this->args['setlang']);
		$category_key = str_replace('-', '', $rs['category_key']) ? $rs['category_key'] : 'category';
		$rs['category_url'] = $rs['redirect'] ? $rs['redirect'] : category_url($rs['category_id'], $category_key);
		return $rs;
	}

	protected function vars(){
		$vars = array(
			array('category', 'system_req'),
			'status',
			'parentid',
			'category_cache',
			'content_cache',
			'ordernum',
			'lang',
			'category_key',
			'category_tpl',
			'content_tpl',
			'redirect',
			'meta_keywords',
			'meta_description',
			'options'
		);
		return parent::vars($vars);
	}

	public function tree($type = 'li', $parentid = 0, $setlang = ''){
		$key = $setlang ? $parentid .'-'. $setlang : $parentid .'_'. $this->wa->env['lng'];
		$file = DIR ."/dat/cache_sys/category/$type.$key";
		$str = file_get_contents($file);
		if(!$str){
			$func = "generate_tree_$type";
			$str = $this->$func($parentid, $setlang);
			put_file($file, $str);
		}
		return $str;
	}

	private function generate_tree_option($parentid = 0, $setlang = '', $depth = 0){
		$arr = $this->gets(array('sql'=>"A.parentid = '$parentid'", 'setlang'=>$setlang, 'orderby'=>'A.ordernum ASC', 'field'=>'category_id,category,status,redirect'));
		foreach($arr as $rs){
			if($rs['redirect']) continue;
			$bgcolor = '#'. str_repeat(dechex(255 - $depth * 9), 3);
			$fgcolor = $rs['status'] <= 0 ? 'color:#CCC;' : '';
			$sign = $depth ? '|__' : '';
			$indent = str_repeat('&nbsp;', $depth * 4);
			$str .= '<option value="'. $rs['category_id'] .'" style="'. $fgcolor .' background-color:'. $bgcolor .'">'. $indent . $sign . $rs['category'] .'</option>'. $this->generate_tree_option($rs['category_id'], $setlang, ($depth + 1));
		}
		return $str;
	}

	private function generate_tree_li($parentid = 0, $setlang = '', $depth = 0){
		$arr = $this->gets(array('sql'=>"A.parentid = '$parentid'", 'setlang'=>$setlang, 'orderby'=>'A.ordernum ASC', 'field'=>'category,status'));
		foreach($arr as $rs){
			if($rs['status'] <= 0) continue;
			$str .= '<li><a href="'. $rs['category_url'] .'">'. $rs['category'] .'</a>';
			if($substr = $this->generate_tree_li($rs['category_id'], $setlang, ($depth + 1))) $str .= "<ul>$substr</ul>";
			$str .= '</li>';
		}
		return $str;
	}

	public function path($id){
		$sql['field'] = 'A.parentid, A.status, A.category, A.category_key';
		$sql['where'] = "A.category_id = '$id'";
		if($rs = parent::_get($sql)){
			$str = $rs['status'] > 0 ? ' >> <a href="'. category_url($id, $rs['category_key']) .'">'. get_text($rs['category']) .'</a>' : ' >> '. get_text($rs['category']);
		}
		if($rs['parentid'] > 0){
			$str = $this->path($rs['parentid']) . $str;
		}else{
			$str = '<a href="/">'. $this->wa->lng('all.home') .'</a>'. $str;
		}
		return $str;
	}
}
?>