/*******************************************************************************
* KindEditor - WYSIWYG HTML Editor for Internet
* Copyright (C) 2006-2011 kindsoft.net
*
* @author Roddy <luolonghao@gmail.com>
* @site http://www.kindsoft.net/
* @licence http://www.kindsoft.net/license.php
*******************************************************************************/

KindEditor.plugin('pagebreak', function(K) {
	var self = this, name = 'pagebreak';
	self.plugin.pagebreak = {
		edit : function() {
			var html = '<div style="padding:10px 20px;"><div class="ke-dialog-row"><label for="keUrl">Title</label><input class="ke-input-text" type="text" id="keUrl" name="title" value="" style="width:90%;" /></div></div>',
				dialog = self.createDialog({
					name : name,
					width : 400,
					title : self.lang(name),
					body : html,
					yesBtn : {
						name : self.lang('yes'),
						click : function(e){
							var cmd = self.cmd, range = cmd.range, title = titleBox.val();
							self.focus();
							range.enlarge(true);
							cmd.split(true);
							var tail = self.newlineTag == 'br' || K.WEBKIT ? '' : '<p id="__kindeditor_tail_tag__"></p>';
							self.insertHtml('<hr style="page-break-after:always;" class="ke-pagebreak" title="'+ title.replace(/"/g, '\"') +'" />' + tail).hideDialog().focus();
							if (tail !== '') {
								var p = K('#__kindeditor_tail_tag__', self.edit.doc);
								range.selectNodeContents(p[0]);
								p.removeAttr('id');
								cmd.select();
							}
						}
					}
				}),
				div = dialog.div;
			var titleBox = K('[name="title"]', div);
			titleBox[0].focus();
			titleBox[0].select();
		}
	};
	self.clickToolbar(name, self.plugin.pagebreak.edit);
});
